  function [res,sol] = cgs (A, rhs, x0, m, tol) 
%%--------------------------------------------------
%   function [res,sol] = cgs (A, rhs, x0, m, tol) 
% x0  = initial guess on entry -- 
% rhs = rhs, m = number of steps 
% m   = max number of steps 
% tol = tolerance
% res = residuals.. 
% sol = app sol on return 
%%--------------------------------------------------
 sol  = x0; 
 r    = rhs - A * sol; 
 r0   = r;
 p    = r ; 
 u    = r;
 ro1  = r' * r; 
 res(1) = sqrt(ro1) ;
 tol1 = tol*res(1); 
%
 for j=1:m 
     ro  = ro1; 
     Ap  = A * p; 
     alp = ro / (r0'*Ap) ;      %% !! check div by 0
     q   = u - alp * Ap ;
     u   = u+q;
     sol = sol + alp*u;
     r   = r - alp*A*u; 
     rsn = norm(r);   res(j+1) = rsn;    
     if (rsn < tol1) 
        break
     end
     ro1 = r0'*r;
     bet = (ro1 / ro);        %% !! check div by 0
     u   = r + bet*q;
     p   = u + bet*(q + bet*p);
 end
 
         
